﻿
using QuickChat_Service.Repositories.Database;
using System;
using System.Collections.Generic;
using System.Linq;

namespace QuickChat_Service.Repositories.Repositories.Interfaces
{
    public interface ITalkerRepository : IRepository<Talker>
    {
        void EnterChatRoom(int userId, int chatRoomId);
        void LeaveChatRoom(int userId);
        void CreateNewTalker(string talkerAlias);
        Talker GetByAlias(string alias);
        IQueryable<Talker> GetTalkersByRoom(int roomId);
        IQueryable<Talker> GetTalkersBySession(int sessionId);
    }
}
